Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.exist.xquery
Class AbstractExpression

    java.lang.Object
      org.exist.xquery.AbstractExpression

All Implemented Interfaces:
  Expression

Direct Known Subclasses:
  AtomicToString, Atomize, BindingExpression, CastableExpression, CastExpression, CombiningExpression, ConditionalExpression, DynamicCardinalityCheck, DynamicNameCheck, DynamicTypeCheck, ExtensionExpression, FilteredExpression, InstanceOfExpression, LiteralValue, Modification, NodeConstructor, PathExpr, Step, TreatAsExpression, TypeswitchExpression, UntypedValueCheck, VariableDeclaration, VariableReference

public abstract class AbstractExpression
extends java.lang.Object
implements Expression

Field Summary

Fields inherited from interface org.exist.xquery.Expression
`DOT_TEST, EXPRESSION_ID_INVALID, IGNORE_CONTEXT, IN_PREDICATE, IN_UPDATE, IN_WHERE_CLAUSE, NO_CONTEXT_ID, SINGLE_STEP_EXECUTION`

Constructor Summary
`AbstractExpression(XQueryContext context)`

Method Summary
`void` | `accept(ExpressionVisitor visitor)` Start traversing the expression tree using the specified `ExpressionVisitor`.
`Sequence` | `eval(Sequence contextSequence)` Evaluate the expression represented by this object.
`abstract Sequence` | `eval(Sequence contextSequence, Item contextItem)` Evaluate the expression represented by this object.
`XQueryAST` | `getASTNode()` Returns the `XQueryAST` node from which this expression has been constructed by the parser.
`int` | `getCardinality()` The default cardinality is `Cardinality.EXACTLY_ONE`.
`DocumentSet` | `getContextDocSet()`
`int` | `getContextId()`
`int` | `getDependencies()` Returns `Dependency.DEFAULT_DEPENDENCIES`.
`int` | `getExpressionId()` Returns an id which uniquely identifies this expression within the compiled expression tree of the query.
`void` | `resetState()` Called to inform an expression that it should reset to its initial state.
`abstract int` | `returnsType()` The static return type of the expression.
`void` | `setASTNode(XQueryAST ast)`
`void` | `setContextDocSet(DocumentSet contextSet)`
`void` | `setPrimaryAxis(int axis)`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.exist.xquery.Expression
`analyze, dump`

Constructor Detail

### AbstractExpression

    public AbstractExpression(XQueryContext context)

Method Detail

### getExpressionId

    public int getExpressionId()

  Description copied from interface: `Expression`
  Returns an id which uniquely identifies this expression within the compiled expression tree of the query.

  Specified by:
    `getExpressionId` in interface `Expression`
  Returns:
    unique id or `Expression.EXPRESSION_ID_INVALID`

### getContextId

    public int getContextId()

  Specified by:
    `getContextId` in interface `Expression`

### eval

    public Sequence eval(Sequence contextSequence)
                  throws XPathException

  Description copied from interface: `Expression`
  Evaluate the expression represented by this object. An overloaded method which just passes the context sequence depending on the expression context.

  Specified by:
    `eval` in interface `Expression`
  Throws:
    `XPathException`

### eval

    public abstract Sequence eval(Sequence contextSequence,
                                  Item contextItem)
                           throws XPathException

  Description copied from interface: `Expression`
  Evaluate the expression represented by this object. Depending on the context in which this expression is executed, either the context sequence, the context item or both of them may be set. An implementing class should know how to handle this. The general contract is as follows: if the `Dependency.CONTEXT_ITEM` bit is set in the bit field returned by `Expression.getDependencies()`, the eval method will be called once for every item in the context sequence. The contextItem parameter will be set to the current item. Otherwise, the eval method will only be called once for the whole context sequence and contextItem will be null. eXist tries to process the entire context set in one, single step whenever possible. Thus, most classes only expect context to contain a list of nodes which represents the current context of the expression. The position() function in XPath is an example for an expression, which requires both, context sequence and context item to be set. The context sequence might be a node set, a sequence of atomic values or a single node or atomic value.

  Specified by:
    `eval` in interface `Expression`
  Parameters:
    `contextSequence` - the current context sequence.
    `contextItem` - a single item, taken from context. This defines the item, the expression should work on.
  Throws:
    `XPathException`

### returnsType

    public abstract int returnsType()

  Description copied from interface: `Expression`
  The static return type of the expression. This method should return one of the type constants defined in class `Type`. If the return type cannot be determined statically, return Type.ITEM.

  Specified by:
    `returnsType` in interface `Expression`

### resetState

    public void resetState()

  Description copied from interface: `Expression`
  Called to inform an expression that it should reset to its initial state. All cached data in the expression object should be dropped. For example, the document() function calls this method whenever the input document set has changed.

  Specified by:
    `resetState` in interface `Expression`

### getCardinality

    public int getCardinality()

  The default cardinality is `Cardinality.EXACTLY_ONE`.

  Specified by:
    `getCardinality` in interface `Expression`

### getDependencies

    public int getDependencies()

  Returns `Dependency.DEFAULT_DEPENDENCIES`.

  Specified by:
    `getDependencies` in interface `Expression`
  Returns:
    set of bit-flags
  See Also:
    `Expression.getDependencies()`

### setPrimaryAxis

    public void setPrimaryAxis(int axis)

  Specified by:
    `setPrimaryAxis` in interface `Expression`

### setContextDocSet

    public void setContextDocSet(DocumentSet contextSet)

  Specified by:
    `setContextDocSet` in interface `Expression`

### getContextDocSet

    public DocumentSet getContextDocSet()

  Specified by:
    `getContextDocSet` in interface `Expression`

### accept

    public void accept(ExpressionVisitor visitor)

  Description copied from interface: `Expression`
  Start traversing the expression tree using the specified `ExpressionVisitor`.

  Specified by:
    `accept` in interface `Expression`
  Parameters:
    `visitor` -

### setASTNode

    public void setASTNode(XQueryAST ast)

  Specified by:
    `setASTNode` in interface `Expression`

### getASTNode

    public XQueryAST getASTNode()

  Description copied from interface: `Expression`
  Returns the `XQueryAST` node from which this expression has been constructed by the parser. This node contains location information (line number and column) important for error reports.

  Specified by:
    `getASTNode` in interface `Expression`
  Returns:
    XQueryAST node

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Wolfgang Meier. All rights reserved.